'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeMapper = require('./typeMapper');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _graphql = require('graphql');

var _graphqlRelay = require('graphql-relay');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Create a GraphQLObjectType from a
 * a thinky model
 *
 * @param Model
 * @param fields
 * @param options
 */

(function (Model) {
  var _fields = arguments.length <= 1 || arguments[1] === undefined ? function () {} : arguments[1];

  var options = arguments.length <= 2 || arguments[2] === undefined ? {} : arguments[2];


  var GraphQLDefinition = (0, _typeMapper.toGraphQLDefinition)(Model, {
    exclude: options.exclude,
    only: options.only,
    map: options.map,
    globalId: options.globalId,
    allowNull: options.allowNull
  });

  return new _graphql.GraphQLObjectType({
    name: _lodash2.default.upperFirst(Model._schema._model._name),
    fields: function fields() {
      return _extends({}, GraphQLDefinition, _fields());
    }
  });
});

export {};