'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

/**
 * Create a GraphQLObjectType from a
 * a thinky model
 *
 * @param Model
 * @param fields
 * @param options
 */


exports.default = function (Model) {
  var options = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

  var GraphQLDefinition = (0, _typeMapper.toGraphQLDefinition)(Model, {
    exclude: options.exclude,
    only: options.only,
    map: options.map,
    globalId: options.globalId,
    allowNull: options.allowNull
  });

  return new _graphql.GraphQLObjectType({
    name: _lodash2.default.upperFirst(Model._schema._model._name),
    fields: function fields() {
      var fieldDef = _extends({}, GraphQLDefinition);

      if (typeof options.fields === 'function') {
        Object.assign(fieldDef, options.fields());
      } else if (_typeof(options.fields) === 'object') {
        Object.assign(fieldDef, options.fields);
      }

      return fieldDef;
    },
    interfaces: function interfaces() {
      return options.interfaces || [];
    }
  });
};

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _graphql = require('graphql');

var _typeMapper = require('./typeMapper');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }